;---------------------------------------UDOs------------------------------------
opcode Vocoder, a, aakkkpp

as1,as2,kmin,kmax,kq,ibnd,icnt  xin

if kmax < kmin then
ktmp = kmin
kmin = kmax
kmax = ktmp
endif

if kmin == 0 then 
kmin = 1
endif

if (icnt >= ibnd) goto bank
abnd   Vocoder as1,as2,kmin,kmax,kq,ibnd,icnt+1

bank:
kfreq = kmin*(kmax/kmin)^((icnt-1)/(ibnd-1))
kbw = kfreq/kq
an  butterbp  as2, kfreq, kbw
an  butterbp  an, kfreq, kbw
as  butterbp  as1, kfreq, kbw
as  butterbp  as, kfreq, kbw
ao balance as, an

amix = ao + abnd

     xout amix

endop

;----------------------------------------End--------------------------------------

alwayson 100 ;Starts mixer instrument
alwayson 50 ;Starts Reverb Instrument

;-----------------------------Set Levels For Mixer--------------------------

						;------------------Instruments-----------------
						
	MixerSetLevel_i 1, 100, .5 ;Drums
	MixerSetLevel_i 2, 100, .5 ;Distorted Drums
	MixerSetLevel_i 3, 100, .25 ;Bass 1
	;MixerSetLevel_i 4, 100, igain ;Live Ins
	MixerSetLevel_i 5, 100, .15 ;Bass 2
	MixerSetLevel_i 6, 100, .5 ;Sample Player
	
					;-----------------------Returns-------------------
	
	MixerSetLevel_i 50, 100, .25 ;Glueverb
	MixerSetLevel_i 49, 100, .5 ;Realtime Stretch

;----------------------------------------End--------------------------------------

;----------------------------Drum Function Tables-------------------------

giKick ftgen 1, 0, 131072, 1, "Samples/Cheetah/BD.wav", 0, 0, 0 ;Kick
giSnare ftgen 2, 0, 131072, 1, "Samples/Cheetah/SD.wav", 0, 0, 0 ;Snare
giHH1 ftgen 3, 0, 131072, 1,  "Samples/Cheetah/HH1.wav", 0, 0, 0 ;HH1
giHH2 ftgen 4, 0, 131072, 1, "Samples/Cheetah/HH2.wav", 0, 0, 0 ;HH2
giHHo ftgen 5, 0, 131072, 1, "Samples/Cheetah/HHo.wav", 0, 0, 0 ;HHo
giCrash ftgen 6, 0, 131072, 1, "Samples/Cheetah/Crash.wav", 0, 0, 0 ;Crash
giSDPerc1 ftgen 7, 0, 131072, 1, "Samples/Cheetah/SDPerc1.wav", 0, 0, 0 ;SDPerc1
giSDPerc2 ftgen 8, 0, 131072, 1, "Samples/Cheetah/SDPerc2.wav", 0, 0, 0 ;SDPerc2
giTom1 ftgen 9, 0, 131072, 1, "Samples/Cheetah/Tom1.wav", 0, 0, 0 ;Tom1
giTom2 ftgen 10, 0, 131072, 1, "Samples/Cheetah/Tom2.wav", 0, 0, 0 ;Tom2
giTom3 ftgen 11, 0, 131072, 1, "Samples/Cheetah/Tom3.wav", 0, 0, 0 ;Tom3
giSimTom ftgen 13, 0, 131072, 1, "Samples/Cheetah/SDSTom.wav", 0, 0, 0 ;Simmons SDS2000 Tom

;---------------------------------------End---------------------------------------

;--------------------------Synth Function Tables--------------------------

;Synth F Tables
giSaw ftgen 12, 0, 16384, 10, 1, 0.5, 0.3, 0.25, 0.2, 0.167, 0.14, 0.125, .111 ;Sawtooth Wave

;--------------------------------------End---------------------------------------

;--------------------------Globals-------------------------

garev init 0		;Initialize global reverb variable
gain1 init 0 ;Initialise global audio input 1 (from interface)
gain2 init 0 ;Initialise global audio input 2 (from interface)

;gain1/2 are patched in instr 4

;----------------------------End----------------------------

;----------------------Instruments-----------------------

instr 1 ;Drums
	
	kamp = p4 ;Velocity
	ift = p5 ;Function Table Number
	
	asig poscil kamp, .3, ift ;Plays F-Table
	;outs asig, asig ;Outputs
	
	;Send to Master
	MixerSend asig, 1, 100, 0 ;L
	MixerSend asig, 1, 100, 1 ;R
	
	garev = garev + asig*.5

endin

instr 2 ;Distorted Drums
	
	kamp = p4 ;Velocity
	ift = p5 ;Function Table Number
	
	asig poscil kamp, .3, ift ;Plays F-Table
	
	aout distort1 asig, 2, .5, .5, .3, 1
	
	;outs aout*.5, aout*.5 ;Outputs
	
	;Send to Master
	MixerSend aout, 2, 100, 0
	MixerSend aout, 2, 100, 1
	
	garev = garev + asig*.5

endin

instr 3 ;Bass 1 (From Ryan's CA2)

	istart = 26.409
	iend = 11.956
	idepth = 0.374
	iatt = 0.001 ; Must be above 0
	idec = 3.718
	islev = .75
	irel = .3
	iamp = 0.5
	itime = irel
	irevl = 0.502
	imeth = 2
	iparm1 = 4.3
	iparm2 = 0 ;not necessary for this imeth
	ivdepth = 0.052
	kvrate = 11.197
	kdist = 20
	kfreq = 800
	kres = 0.153

	ipch = p4
	ifreq = cpspch(ipch)
	;printk2 kfreq

	kenv madsr iatt, idec, islev, irel
	krate linseg istart, itime, iend
	ktrem oscili idepth, krate
	kvib oscili ivdepth, kvrate
	asig pluck iamp+ktrem, ifreq*4+kvib, i(kfreq)*4, 0, imeth, iparm1, iparm2

	;Sub
	asig1 oscil iamp+ktrem, (kfreq*4)+kvib

	afilt lpf18 (asig+(asig1*.5)), kfreq, kres, kdist
	aout balance afilt, (asig+asig1)*.5

     ;outs aout*kenv*iamp, aout*kenv*iamp
     
   	;Send to Master  
		MixerSend aout, 3, 100, 0
		MixerSend aout, 3, 100, 1

	garev = (irevl*aout*kenv*iamp)*.5


endin

instr 4 ;Microphone/Live Inputs

	;ion init 0 ;Switch for turning outputs on (1) or off (0)

	ain1, ain2 ins
	
	gain1 = ain1 ;Patching these inputs to global variables
	gain2 = ain2

endin

instr 5 ;Bass 2

	ifreq = p4 ;CPS value from score
	kenv madsr .01, 1, .5, .01 ;Envelope
	avco1 vco2 kenv, ifreq ;VCO 1
	avco2 vco2 kenv, ifreq*1.005 ;VCO 2
	
	asub vco2 kenv, ifreq*.5, 4, .3 ;Sub
	
	asig sum avco1, avco2, asub

	;aoutL, aoutR freeverb asig, asig, .9, .35 ;Room Reverb for softening
	
	aoutL, aoutR reverbsc asig, asig, 0.9, 700
	
		;outs (asig*.25) + aoutL, (asig*.25) + aoutR
		MixerSend aoutL + asig*.25, 5, 100, 0
		MixerSend aoutR + asig*.25, 5, 100, 1
		
		;garev = garev+asig*.05

endin

instr 6 ;Sample Player

	kamp = p4 ;Velocity
	Sfile strget p5 ;Function Table Number
	ktime = p6 ;Stretch time (half is 0.5, normal speed is 1)
	ivocoder = p7 ;l(1 is on, 0 is off)
	;ipch = p8
	
	asigL, asigR soundin Sfile
	asig sum asigL, asigR

		;Time Stretch

		fsig pvsanal asig, 1024, 256, 1024, 1
	
		ibuf, kt pvsbuffer fsig, 50 ; 50 second buffer using fsig
	
		khan init ibuf ;initialise handle to buffer (only useful if multiple buffers exist)
	
		;If multiple buffers exist, have an if and else here
	
	
		fsb pvsbufread kt*ktime, khan ;read buffer
	
		aout pvsynth fsb ;resynth to a-rate variable
		
		;Vocoder
		
		if (ivocoder == 1) then
				anoise noise .25, .99 ;Creates noise signal
				avoc Vocoder anoise, aout, 80, 12000, 1.5, 16
		else
				avoc = aout
		endif	
	
	;Send to Master
	MixerSend avoc*kamp, 6, 100, 0 ;L
	MixerSend avoc*kamp, 6, 100, 1 ;R
	
	garev = garev + avoc*.5

endin

;----------------------------End----------------------------

;-----------------------FX Returns----------------------

;               Counting down from 50

instr 49 ;Realtime Paulstretch

	ain,ain2 ins ;getting input from microphones
	
	istretchtime = p4 ;.can't go over 1 (Which would be normal speed)
	
	;ain soundin "paint.wav" ;For testing

	fsig pvsanal ain2, 1024, 256, 1024, 1
	
	ibuf, kt pvsbuffer fsig, 10 ; 10 second buffer using fsig
	
	khan init ibuf ;initialise handle to buffer (only useful if multiple buffers exist)
	
	;If multiple buffers exist, have an if and else here
	
	
	fsb pvsbufread kt*istretchtime, khan ;read buffer
	
	aout pvsynth fsb ;resynth to a-rate variable
	
	;Send to Master
	MixerSend aout, 49, 100, 0
	MixerSend aout, 49, 100, 1
	

endin

;From Brian Carty's schroederlp.csd
instr 50 ; Glueverb (I guess)

irvt = 1.5
ifc = 3000	;lowpass cutoff freq
irev1 = .09683
irev2 = .03292
ilpt1 = .0297
ilpt2 = .0371
ilpt3 = .0411
ilpt4 = .0437
ilpt5 = .005
ilpt6 = .0017
		
ig1 pow 0.001, ilpt1/irvt
ig2 pow 0.001, ilpt2/irvt
ig3 pow 0.001, ilpt3/irvt
ig4 pow 0.001, ilpt4/irvt

ac1	delayr ilpt1
af1	tone ac1, ifc		;low pass delayed signal...more and more filtering as signal fedback...
	delayw garev+(af1*ig1)

ac2	delayr ilpt2
af2	tone ac2, ifc
	delayw garev+(af2*ig2)

ac3	delayr ilpt3
af3	tone ac3, ifc
	delayw garev+(af3*ig3)

ac4	delayr ilpt4
af4	tone ac4, ifc
	delayw garev+(af4*ig4)

ap1 alpass (ac1+ac2+ac3+ac4)/2, irev1, ilpt5
ap2 alpass ap1, irev2, ilpt6

	;Send to Master
	MixerSend ap2*.5, 50, 100, 0
	MixerSend ap2*.5, 50, 100, 1

garev = 0



endin

;----------------------------End----------------------------

;----------------------Mixer/Master---------------------

instr 100

	aoutL init
	aoutR init
	
	;Drums
	aDrumsL MixerReceive 100, 0 ;Instrument 1, Channel 0 for Left
	aDrumsR MixerReceive 100, 1
	
	;Distorted Drums
	aDistDrL MixerReceive 2, 0
	aDistDrR MixerReceive 2, 1 ;Instrument 2, Channel 1 for Right
	
	;Bass 1
	aBass1L MixerReceive 3, 0
	aBass1R MixerReceive 3, 1
/*	
	;Live Ins
	aInsL MixerReceive 4, 0
	aInR MixerReceive 4, 1
*/	

	;Bass 2
	aBass2L MixerReceive 5, 0
	aBass2R MixerReceive 5, 1
	
	;Sample Player
	aSampleL MixerReceive 6, 0
	aSampleR MixerReceive 6, 1
	
					;------------Returns-----------
					
	;Glueverb
	aGlueL MixerReceive 50, 0
	aGlueR MixerReceive 50, 1
	
	;Realtime Stretch
	aStretchL MixerReceive 49, 0
	aStretchR MixerReceive 49, 1
	
					;------------Mixing------------
					
					;Instrument Levels
					kDrumGain MixerGetLevel 1, 100 ;Drums
					kDistDrGain MixerGetLevel 2, 100 ;Distorted Drums
					kBass1Gain MixerGetLevel 3, 100 ;Bass 1
					
					kBass2Gain MixerGetLevel 5, 100 ;Bass 2
					
					kSampleGain MixerGetLevel 6, 100 ;Sample Player
					
					;Returns Levels
					kGlueGain MixerGetLevel 50, 100 ;Glueverb
					kStretchGain MixerGetLevel 49, 100 ;Timestretch
	
					;Mix Tracks
		aoutL = aDrumsL*kDrumGain + aDistDrL*kDistDrGain + aBass1L*kBass1Gain + aGlueL*kGlueGain + aStretchL*kStretchGain + aBass2L*kBass2Gain
		
		aoutR = aDrumsR*kDrumGain + aDistDrR*kDistDrGain + aBass1R*kBass1Gain + aGlueR*kGlueGain + aStretchR*kStretchGain + aBass2R*kBass2Gain
		
		;May add reverbsc in the future before outs
					outs aoutL, aoutR
					
	MixerClear ;Resets everything to 0

endin

;---------------------------End-----------------------------
